'''
Script to write message to SARA-R410 memory
'''

import serial
import time
import sys
import json

parameter = sys.argv[1:]  # Exclude the script name
port='/dev/'+parameter[0] # ex: ttyAMA2
message = parameter[1]  # ex: Hello

#get baudrate
baudrate = 115200

ser = serial.Serial(
    port=port,  #USB0 or ttyS0
    baudrate=baudrate, #115200 ou 9600
    parity=serial.PARITY_NONE, #PARITY_NONE, PARITY_EVEN or PARITY_ODD
    stopbits=serial.STOPBITS_ONE,
    bytesize=serial.EIGHTBITS,
    timeout = 2
)

#0. empty file
#ser.write(b'AT+UDELFILE="sensordata.json"\r')

#1. Open sensordata.json (with correct data size)
size_of_string = len(message)
command = f'AT+UDWNFILE="sensordata.json",{size_of_string}\r'
ser.write((command + '\r').encode('utf-8'))
time.sleep(1)
#2. Write to shell
ser.write(message.encode())

try:
    # Read lines until a timeout occurs
    response_lines = []
    while True:
        line = ser.readline().decode('utf-8').strip()
        if not line:
            break  # Break the loop if an empty line is encountered
        response_lines.append(line)

    # Print the response
    for line in response_lines:
        print(line)

except serial.SerialException as e:
    print(f"Error: {e}")

finally:
    if ser.is_open:
        ser.close()
        #print("Serial closed")

